#pragma once
#ifndef _UTILS_H
#define _UTILS_H

#include <stdlib.h>
#include <iostream>
#include <stdarg.h>
#include <stdio.h>
#include <string>
#include "simpleCL.h"
using namespace std;

struct Result {
	cl_ulong executionTime;
	int *output;
};

sclHard getHardware();
void debug(char* fmt, ...);
int* calculateCPU(int inputSize, int* input);
int* generateIncreasingInput(int size);
int* padInputTo(int* input, int size, int paddedSize);
void printArray(int size, int* input);
void printArrays(int size, int* input, int* one, int* two);
void printArraysDepth(int depth, int size, int* input, int* one, int* two);
void printArrayTree(int size, int* array);
void printMultiArray(int height, int width, int* array);
void printMultiArrayDepth(int depth, int height, int width, int* array);
char* getHardwareName(sclHard hardware);
size_t getMaximumWorkgroupSize(sclHard hardware);

#endif _UTILS_H